<?php
/**
 * Plugin BoostMyPlux
 *
 * @author Yannou90, Cyril MAGUIRE
 **/
class BoostMyPlux extends plxPlugin {

	public $compressor = null; # Objet compressor

	/**
	 * Constructeur de la classe
	 *
	 * @param	default_lang	langue par défaut
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function __construct($default_lang) {
		parent::__construct($default_lang);
		# Ajouts des hooks
		$this->addHook('plxMotorConstruct', 'plxMotorConstruct');
		$this->addHook('IndexEnd', 'IndexEnd');
		$this->addHook('putInCache', 'putInCache');
	}

	/**
	 * Méthode d'initialisation de la racine des fichiers du plugin
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function onActivate() {
		$this->setParam('root', dirname(__FILE__), 'string');			
		$this->saveParams();
	}
	
	/**
	 * Méthode de traitement du hook plxShowConstruct
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function plxMotorConstruct() {
		require 'php_speedy/php_speedy.php';
		$this->compressor = $compressor;
	}

	/**
	 * Méthode qui permet la compression des pages
	 *
	 * @return	stdio
	 * @author	Cyril MAGUIRE
	 **/
	public function IndexEnd() {
		echo "<?php 
		\$plxPlugin = \$plxMotor->plxPlugins->aPlugins['BoostMyPlux']['instance'];

		//Con. the js min library
		if(substr(phpversion(),0,1) == 5) {
			require_once \$plxPlugin->getParam('root').'/php_speedy/libs/php/jsmin.php';
			\$jsmin = new JSMin(\$output);
			\$plxPlugin->compressor->jsmin = \$jsmin;
		}
		
		ob_start();
		\$plxPlugin->compressor->finish(\$output);
		\$output = ob_get_clean();
		?>";
	}

	/**
	 * Méthode permettant d'inclure, en haut de la page header.php du thème, le code nécessaire à la mise en cache des pages
	 * 
	 * @return void
	 * @author Cyril MAGUIRE
	 */
	public function putInCache() {
		include $this->getParam('root').'/_cache.php';
	}
}
?>
